IF( NOT INCLUDED_MACROS )

    MACRO( FIND_SOURCES var )
        SET( ALL_SOURCES "" )
        SET(ARGUMENTS ${ARGN})
        IF(${ARGC} GREATER 1)
            STRING(TOUPPER ${ARGV1} LIB_TYPE)
            IF(${LIB_TYPE} STREQUAL "STATIC" OR ${LIB_TYPE} STREQUAL "SHARED")
                LIST(REMOVE_AT ARGUMENTS 0)
            ENDIF()
        ENDIF()
        SET(ARG_COUNT 0)
        LIST(LENGTH ARGUMENTS ARG_COUNT)
        IF( ${ARG_COUNT} EQUAL 0 )
            FILE( GLOB MY_SOURCES ./*.c ./*.cpp ./*.h )
            SET( ALL_SOURCES ${ALL_SOURCES} ${MY_SOURCES} )
        ELSE()
            FOREACH( ELEMENT ${ARGUMENTS} )
                SET( MY_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${ELEMENT} )
                IF( IS_DIRECTORY ${MY_PATH} )
                    FILE( GLOB MY_SOURCES ${MY_PATH}/*.c ${MY_PATH}/*.cpp ${MY_PATH}/*.h )
                    SET( ALL_SOURCES ${ALL_SOURCES} ${MY_SOURCES} )
                ELSE()
                    SET( ALL_SOURCES ${ALL_SOURCES} ${ELEMENT} )
                ENDIF()
            ENDFOREACH()
        ENDIF()
        SET( ${ARGV0} ${ALL_SOURCES} )
    ENDMACRO()

    # Run gcc compiler with "-dumpversion" and parse major/minor version with a regex.
    FUNCTION(GET_GCC_VERSION COMPILER_VERSION)
        EXEC_PROGRAM(${CMAKE_CXX_COMPILER}
            ARGS ${CMAKE_CXX_COMPILER_ARG1} -dumpversion
            OUTPUT_VARIABLE _COMPILER_VERSION
        )
        STRING(REGEX REPLACE "([0-9])\\.([0-9])(\\.[0-9])?" "\\1.\\2"
            _COMPILER_VERSION ${_COMPILER_VERSION})

        SET(${COMPILER_VERSION} ${_COMPILER_VERSION} PARENT_SCOPE)
    ENDFUNCTION()

    SET( INCLUDED_MACROS TRUE )
ENDIF()
